{

PRT test 1735: For trunc(x), the value of trunc(x) is such that if x is
               positive or zero then 0 <= x-trunc(x) < 1; otherwise 1 <x-
               trunc(x) < 0. It is an error if such a value does not exist.

               ISO 7185 reference: 6.6.6.3

}

program iso7185prt1735(output);

var a: integer;
    b: real;
    e: real;

begin
    {find smallest x st x > maxint
     this is needed when widthof int > width of real,
     eg 64 bit integer, 53 bits real precision
    }
   e := 1;    b := maxint+1.0;
    while b <= maxint do begin
      e := 2*e;
      b := maxint + e;
    end;

   { assign maximum value of integer }
   b := maxint;
   { now move it completely out of range in floating point only }
   b := b+e;
   { now the assignment is invalid }
   a := trunc(b);
   writeln('error not detected: trunc(maxint+', e:1:1, ')');
end.
