{

PRT test 1736: For round(x), if x is positive or zero then round(x) is
               equivalent to trunc(x+0.5), otherwise round(x) is equivalent to
               trunc(x- 0.5). It is an error if such a value does not exist.

               ISO 7185 reference: 6.6.6.3

}

program iso7185prt1736(output);

var a: integer;
    b: real;
    e: real;

begin

    {find smallest x st x > maxint
     this is needed when widthof int > width of real,
     eg 64 bit integer, 53 bits real precision
    }
   e := 1;    b := maxint+1.0;
    while b <= maxint do begin
      e := 2*e;
      b := maxint + e;
    end;

   { assign maximum value of integer }
   b := maxint;
   { now move it completely out of range in floating point only }
   b := b+e;
   { now the assignment is invalid }
   a := round(b);
   writeln('error not detected: round(maxint+', e:1:1, ')');
end.
